      subroutine generate_event_matched(sdif,i_ok,p3,p4,qph)
      include 'shared.inc'
      dimension pin1(0:3),pin2(0:3),qphcm(40,0:3)
      ! p1 --> u, p2 --> dbar, p3 --> neutrino, p4 --> positron
      double precision maaa,mbbb
      complex*16 mwcomplex
      dimension vboost(0:3),q(0:3)
      dimension ama(4)
      dimension p3cm(0:3),p4cm(0:3),qcm(0:3),p1cm(0:3),p2cm(0:3)
      real*4 csi(1)
      character*10 model
      character*6 ord
      common/qedORDER/ord
      common/nphot_mode/nphotmode
      common/input_matching/model
      common/momentainitial/p1cm,p2cm
      common/masseinitial/maaa,mbbb
      common/eventinCOM/p3cm,p4cm,qphcm
      common/resonant/mwcomplex
      common /regulators/ESOFTMAX
      common/partialweights/wlepang,wphoten,wphotang,reg
      common/wparameters/amw,agw
      common/ifirstime_matched/ifirst_exewbck,ifirst_matched,ifirst_in
      data ifirst_matched /0/
      data ifirst_in /0/
      common/chargesmasses_cm/charges(4),amasses(4)
      common/n_phot/nphot
      common/nrandom/ir
      common/sampling_weight/wsampling,spaziofasi,flux
      common/fordebugging/idebugging
      common/svfordebug/svdebug,emtx,emtxsub,wnphot
      common/cosinesforsubtraction/cosu,cosd
      common/scalapersottrazione/sqrtscalesub
      common/deltaerre/deltar
      common/rescaletogmu/dpu
      common/cosinesforcuts/cosenomax,cosenomin
      common/counter_event/icountevent
      data icountevent /0/
      common/subtractedsv/subtractedoalsv
      icountevent = icountevent + 1
      sdif = 0.d0
      w         = 1.d0
      wsampling = 1.d0
      in_conf_spin = 4
ccc      
      isubtract = 1
      if (ifirst_in.eq.0) then
         dpu   = alpha_gf*alpha_gf/alpha/alpha
         nphot = 1
c         call init_alpha
         if (isubtract.eq.1.and.i_pdf.eq.1.and.
     .        (ord.eq.'alpha'.or.ord.eq.'exp')) 
     .        call init_deltaq(mw*rescalepdfscale)
         nphotmax = 0
         do i = 1,20
            sumsez(i)   = 0.d0
            sumsez2(i)  = 0.d0
            sezioni(i)  = 0.d0
            sezioni2(i) = 0.d0
            icounterpartial(i) = 0
         enddo
         mwcomplex = dcmplx(mw,-gw/2.d0)
         amw = mw
         agw = gw
         subtractionpl = 0.d0
         ifirst_in = 1
      endif

! nullifying qph(1...nphot) as many as there were in the previous event...
      do j=0,3
         do k = 1,max(nphot,1)  ! nphot initialized to 1...            
            qph(k,j) = 0.d0
         enddo
         vboost(j) = 0.d0
      enddo

      i_ok = 1
      s = 4.d0*ebeam1*ebeam1
      call get_x1x2pdf(s,pdfjac)
      shat = s*x1pdf*x2pdf
***
      spdf = mw * rescalepdfscale
      spdfcomm = spdf
ccccc      spdf = sqrt(shat)
***
      if (spdf.lt.qpdfmin) then 
         i_ok = 0
         return 
      endif
********
************* W+ W- production at the same time!!
      wwpwm = 1.d0
      if (abs(chfs).gt.0.d0.and.ichfs.eq.2) then
         chfs = 1.d0
         call wraprng(csi,1)
         if (csi(1).le.0.5) chfs = -1.d0
         wwpwm = 2.d0
      endif
**************************************
      call get_is(x1pdf,x2pdf,spdf,wpdfpdf)
      if (ipart1.eq.(ifl+1)) then
         i_ok = 0
         return
      endif

      colfac = 1.d0/3.d0
** I associate Vud2 to pdf weight to enhance efficiency
      Vud2 = 1.d0
***
      if (Vud2.gt.0d0) then
         continue
      else
         i_ok = 0
         return
      endif
***********************************************************************
* The process is generated in the center of mass of the parton system
***********************************************************************
      p1(0) = x1pdf*ebeam1
      p2(0) = x2pdf*ebeam2
      if (p1(0).lt.m1.or.p2(0).lt.m2) then
         i_ok = 0
         return
      endif
      beta1 = 1.d0 !sqrt(1.d0 - m1**2/p1(0)**2)
      beta2 = 1.d0 !sqrt(1.d0 - m2**2/p2(0)**2)

      p1(1) = 0.d0
      p1(2) = 0.d0
      p1(3) = beta1 * p1(0)

      p2(1) = 0.d0
      p2(2) = 0.d0
      p2(3) = -beta2 * p2(0)

      bis = (p1(3)+p2(3))/(p1(0)+p2(0))
      gis =  1.d0/sqrt(1.d0-bis**2)
      vboost(3) = bis

! "*cm" means CoM and up-type particle along +z!!!!!!!! 
      call boost(gis,vboost,p1,p1cm)
      call boost(gis,vboost,p2,p2cm)

! I generate with up-type quark along +z
      imirror = 0
      if ((abs(ipart1).eq.2).or.(abs(ipart1).eq.4)) then
         continue
      else
         imirror = 1
      endif
*********************************************
**** QUANTITIES FOR up down SUBTRACTION CONES !!!
* and for cut efficiency...
cc      sqrtscalesub = p1cm(0) + p2cm(0)
c Maybe it is better to keep always mw for sqrtscalesub
      sqrtscalesub = spdf
      sqrtscalesub = mw

cc no more necessary...
c$$$      rapmax =  etamax
c$$$      rapmin = -etamax
c$$$      rapmax = rapmax + 0.5d0*log((1.d0-bis)/(1+bis))
c$$$      rapmin = rapmin + 0.5d0*log((1.d0-bis)/(1+bis))
c$$$      cos1   = (exp(2.d0*rapmax)-1.d0)/(exp(2.d0*rapmax)+1.d0)
c$$$      cos2   = (exp(2.d0*rapmin)-1.d0)/(exp(2.d0*rapmin)+1.d0)
c$$$
c$$$      cosenomax = cos1
c$$$      cosenomin = cos2
c$$$
c$$$      cos1   = cos(0.5d0*acos(cos1))
c$$$      cos2   = cos(0.5d0*(pi+acos(cos2)))
c$$$      cosu   = cos1
c$$$      cosd   = cos2
c$$$      if (imirror.eq.1) then
c$$$         th1 = acos(cos1)
c$$$         th2 = acos(cos2)
c$$$         cosd = cos(pi-th1)
c$$$         cosu = cos(pi-th2)
c$$$         
c$$$         aaa = cosenomax
c$$$         cosenomax = cos(pi-acos(cosenomin))
c$$$         cosenomin = cos(pi-acos(aaa))
c$$$      endif
******** END SUBTRACTION
*************************************************
      if (imirror.eq.0) then
         continue
      else
!         p1cm and p2cm have to be mirrored and exchanged!
         ptmp(0) = p1cm(0)
         ptmp(1) = p1cm(1)
         ptmp(2) = p1cm(2)
         ptmp(3) = p1cm(3)

         p1cm(0) =  p2cm(0)
         p1cm(1) =  p2cm(1)
         p1cm(2) =  p2cm(2)
         p1cm(3) = -p2cm(3)

         p2cm(0) =  ptmp(0)
         p2cm(1) =  ptmp(1)
         p2cm(2) =  ptmp(2)
         p2cm(3) = -ptmp(3)
      endif

*** beginning event generation...
      einitial = p1cm(0)+p2cm(0)
      flux = 8.d0 * (einitial/2.d0)**2
ccc FIXED  in common    esoft = eps*einitial/2.d0
      if (i_pdf.eq.1) then
         esoftmax = 0.004d0
         if (einitial.gt.200.d0) esoftmax = 0.04d0
         if (einitial.gt.500.d0) esoftmax = 0.1d0
c!C!C!C!C!C!C
         esoftmax = eps*einitial/2.d0
c!C!C!C!C!C!C
      endif

      esoft = esoftmax
      call multiplicityv2(eps,einitial,ng,wnphot)

      nsignal = 0
      if (ng.lt.-1000) then
         nsignal = ng
         if (nsignal.eq.-1002) ng=0
         if (nsignal.eq.-1003) ng=1
      endif
      nphot = ng

      if (imirror.eq.0) then
         ama(1) = m1
         ama(2) = m2
      else
         ama(1) = m2
         ama(2) = m1
      endif
      ama(3) = mfs
      ama(4) = 0.d0
      ama3   = ama(3)

! for the moment, only u dbar --> e+ neutrino !!!!!!!
      charges(1) = 2.d0/3.d0
      charges(2) =-1.d0/3.d0
      charges(3) =-1.d0
      charges(4) = 0.d0
      amasses(1) = ama(1)
      amasses(2) = ama(2)
      amasses(3) = ama(3)
      amasses(4) = 0.d0
****
      e1 = (einitial**2 + ama(1)**2 - ama(2)**2)/2.d0/einitial
      e2 = einitial - e1
      p1cm(0) = e1
      p1cm(1) = 0.d0
      p1cm(2) = 0.d0
      p1cm(3) = e1*sqrt(1.d0-ama(1)**2/e1**2)
      p2cm(0) =  e2
      p2cm(1) =  0.d0
      p2cm(2) =  0.d0
      p2cm(3) = -e2*sqrt(1.d0-ama(2)**2/e2**2)

*** Without masses !!!!!!!
c      if (ng.eq.0) then
c         p1cm(0) =  einitial/2.d0
c         p1cm(1) =  0.d0
c         p1cm(2) =  0.d0
c         p1cm(3) =  p1cm(0)
c         p2cm(0) =  einitial/2.d0
c         p2cm(1) =  0.d0
c         p2cm(2) =  0.d0
c         p2cm(3) = -p2cm(0)
c         ama3    =  0.d0
c      endif
*** end without masses !!!!!!!

      sdif = wnphot

      maaa = ama(1)
      mbbb = ama(2)
      call phasespace(p1cm,p2cm,p3cm,p4cm,qphcm,ng,
     .     ama3,ama(4),esoft,w,phsp,ie)
      if (ie.ge.1) ie = 1
      if (ie.gt.0) then
         i_ok = 0
         return
      endif

      wsampling  = w
      spaziofasi = phsp

      sdif = sdif * phsp * w

      shat = (p1cm(0) + p2cm(0))**2
      E1   = p1cm(0)
      E2   = p2cm(0)

      do k = 0,3
         qcm(k) = qphcm(1,k)
      enddo
**********************************************
* Cuts are applied....
* all FS momenta are reported in the laboratory
      if (imirror.eq.1) then
         call mirror(p3cm,p3)
         call mirror(p4cm,p4)
      else
         do k = 0,3
            p3(k) = p3cm(k)
            p4(k) = p4cm(k)
         enddo
      endif
      vboost(3) = -bis
      call boost(gis,vboost,p3,p3)
      call boost(gis,vboost,p4,p4)
      if (ng.gt.0) then
         do kkk = 1,ng
            ptmp(0) = qphcm(kkk,0)
            ptmp(1) = qphcm(kkk,1)
            ptmp(2) = qphcm(kkk,2)
            ptmp(3) = qphcm(kkk,3)
            if (imirror.eq.1) call mirror(ptmp,ptmp)
            call boost(gis,vboost,ptmp,ptmp)
            qph(kkk,0) = ptmp(0) 
            qph(kkk,1) = ptmp(1) 
            qph(kkk,2) = ptmp(2)
            qph(kkk,3) = ptmp(3)
         enddo
      endif

      call cuts(p3,p4,qph,icut)
      if (icut.eq.1) then 
         i_ok = 0
         return
      endif
**********************************************
*** ng-photons real contribution
ccc      goto 111 ! phase space!!
      call real_photons(model,ng,einitial,p3cm,p4cm,qphcm,ie,
     >     imtx,emtx,iemap,emtxsub)
      if (iemap.gt.0) then
         i_ok = 0
         return
      endif

** soft+virtual contribution
      if (ie.eq.0) then
         sv = 1.d0
         if (nsignal.eq.0)         
     .        call svfactor(model,ng,einitial,p3cm,p4cm,eps,sv)
c#         if (ng.eq.0.and.ord.ne.'born') then
c#ctest            sv = sv * (1.d0 + 2.d0*deltar/sv)
c#            sv = sv * (1.d0 + 0.d0*deltar/sv)
c#         endif
         sdif = sdif * sv
      endif
      svdebug = sv
****
      if (nsignal.eq.-1003) emtx = emtxsub

      if (ng.eq.1) then
         emtx = emtx + 1.d0 * emtxsub/sv
      endif
      emtx = emtx/in_conf_spin ! divided by initial spin conf. 
      emtx = emtx*convfac/flux ! divided by the flux
      emtx = emtx*Vud2*colfac
      sdif = sdif * emtx
****
      sdbck = sdif
      sdif = sdif * dpu
 111  continue ! phasespace!!
c      if ((isubtract.eq.1.or.nsignal.eq.-1002).and.ng.eq.0
c     .     .and.i_pdf.eq.1.and.ie.eq.0
c     .     .and.ord.eq.'alpha') then
      if ((isubtract.eq.1).and.ng.eq.0
     .     .and.i_pdf.eq.1.and.ie.eq.0
     .     .and.(ord.eq.'alpha'.or.ord.eq.'exp')) then
         sdborn = sdif/sv
         call get_subtraction(x1pdf,x2pdf,bigq1,bigq2)
         q1 = pdf1(ipart1)
         q2 = pdf2(ipart2)
         subtract = (bigq1/q1 + bigq2/q2 + subtractedoalsv)*sdborn
         sdif = sdif - subtract
      endif
**********************************************
* The jacobian for the MC integration is calculated
      xjac = pdfjac    *wwpwm
      xjac = xjac*wpdfpdf          ! for pdfs...
      sdif = sdif*xjac
      sumsez(ng+1)  = sumsez(ng+1) + sdif
      sumsez2(ng+1) = sumsez2(ng+1)+ sdif**2
      icounterpartial(ng+1) = icounterpartial(ng+1) + 1
      if (ng.gt.nphotmax) nphotmax = ng
      return
      end
********************************************************
      subroutine generate_event_OLDPS(sdif,i_ok,p3,p4,qph)
      include 'shared.inc'
      real*4 csi(1),rnd(1)
      dimension x(40),xvect(10),vboost(0:3)
      common/firstgenevent/ifirst
      data ifirst/1/
      do i=0,3
         vboost(i) = 0d0
      enddo
      i_ok = 1
      s = 4.d0*ebeam1*ebeam1
      call get_x1x2pdf(s,pdfjac)
      
      spdf = sqrt(4.d0*x1pdf*x2pdf*ebeam1*ebeam2) ! sqrt of the pdf Q^2 scale
      spdfcomm = spdf
      spdf = mw * rescalepdfscale
      if (boson.eq.'Z') spdf = mz * rescalepdfscale
   
      if (spdf.lt.qpdfmin) then
         i_ok = 0
         return 
      endif

************* W+ W- production at the same time!!
      wwpwm = 1.d0
      if (abs(chfs).gt.0.d0.and.ichfs.eq.2) then
         chfs = 1.d0
         call wraprng(csi,1)
         if (csi(1).le.0.5) chfs = -1.d0
         wwpwm = 2.d0
      endif
**************************************
      call get_is(x1pdf,x2pdf,spdf,wpdfpdf)
      if (ipart1.eq.(ifl+1)) then
         i_ok = 0
         return
      endif
***********************************************************************
* The process is generated in the center of mass of the parton system
*
* The cos_theta and phi integration variable are extracted
* ccm is sampled for W according (1-c)**2 or (1+c)**2
      call wraprng(rnd,1)
      if (boson.eq.'W') then
         if ((abs(ipart1).eq.2).or.(abs(ipart1).eq.4)) then   
            ccm = 1.d0-2.d0*(1.d0-rnd(1))**(1.d0/3.d0)
            xjacccm = 8.d0/3.d0/(1.d0-ccm)/(1.d0-ccm)         
         else
            ccm = 2.d0*(1.d0-rnd(1))**(1.d0/3.d0)-1.d0
            xjacccm = 8.d0/3.d0/(1.d0+ccm)/(1.d0+ccm)
         endif 
      else  ! if (boson.eq.'Z')
c      ccm = 2.d0 * rnd(1) - 1.d0
c      xjacccm = 2.d0
         ccm = ccmgen(wei)
         xjacccm = wei
      endif
      call wraprng(rnd,1)
      phi  = 2.d0*pi*rnd(1)

      bis = (x1pdf*ebeam1-x2pdf*ebeam2)/(x1pdf*ebeam1+x2pdf*ebeam2)
                                      ! beta (speed) of the center of mass
      gis =  1.d0/sqrt(1.d0-bis**2)   ! and gamma....

      E1l = x1pdf*ebeam1
      E2l = x2pdf*ebeam2
*
* the energy in the parton CoM is calculated. Of course, E1 and E2 are equal!
*
      E1 = gis*E1l*(1.d0-bis)
      E2 = gis*E2l*(1.d0+bis)

! 18 / 8 / 2003
!!! I recalculate E1 and E2 for massive quarks. I use the convention that
!!! xpdf are fraction of proton p_z carried by quarks, as agreed with Wieslaw.
!!! However, in my opinion, the ambiguity remains....

      if (i_scheme.eq.1) then 
!! I use the "p_z scheme"....
         pz1l =  x1pdf*ebeam1
         pz2l = -x2pdf*ebeam2   ! it is along the negative z axis
      
         E1l = sqrt(pz1l**2 + m1**2)
         E2l = sqrt(pz2l**2 + m2**2)
      endif
!! or the "E scheme"....
      if (i_scheme.eq.2) then
         E1l = x1pdf*ebeam1
         E2l = x2pdf*ebeam2
      
         if (E1l.lt.m1.or.E2l.lt.m2) then
            i_ok = 0
            return
         endif
         
         pz1l = sqrt(E1l**2 - m1**2)
         pz2l = -sqrt(E2l**2 - m2**2)
      endif
!!
!! or the "light cone scheme"....
      if (i_scheme.eq.3) then
         sqr2 = sqrt(2.d0)
         
         plcp1 = 2.d0 * ebeam1 / sqr2
         plcp2 = 2.d0 * ebeam2 / sqr2
         
         qlc1 =  x1pdf * plcp1
         qlc2 =  x2pdf * plcp2

         E1l  = 2.d0*qlc1**2+m1**2
         E1l  = E1l/2.d0/sqr2/qlc1
         
         E2l  = 2.d0*qlc2**2+m2**2
         E2l  = E2l/2.d0/sqr2/qlc2
         
         if (E1l.lt.m1.or.E2l.lt.m2) then
            i_ok = 0
            return
         endif
         
         pz1l = sqrt(E1l**2-m1**2)
         pz2l = -sqrt(E2l**2-m2**2)
      endif
!!
      if (i_scheme.eq.4) then
         E1l = x1pdf*ebeam1
         E2l = x2pdf*ebeam2
         
         pz1l =  E1l
         pz2l = -E2l         
      endif

      E1  = gis*(E1l - pz1l*bis)
      E2  = gis*(E2l - pz2l*bis)

      E1cm = E1 ! to be passed in a common, since E1 and E2 conflict with a  
      E2cm = E2 ! soubroutine argument....

      pz1  = gis*(pz1l - E1l*bis)
      pz2  = gis*(pz2l - E2l*bis)
*
* the QED SF scale is set....
*
      q2 = 4.d0*(E1)**2
* .... and the QED PS is called for the final state particles
      call qed_stuff(E1,E2,q2,ccm,phi,p3,p4,qph,x1,x2,x3,x4,ierror)
      if (ierror.gt.0) then
         i_ok = 0
         return
      endif
* the 'shat' of the process is calculated
      shat_old = 4.d0*x1*x2*E1*E2

! 19 / 8 / 2003 ! I calculate massive shat
      shat = m1**2 + m2**2 + 2.d0 * (E1*E2 - pz1 * pz2)
      if (i_scheme.eq.4) shat = 2.d0 * (E1*E2 - pz1 * pz2)
      ! which is the same as:
      !shataaa = m1**2 + m2**2 + 2.d0 * (E1l*E2l - pz1l * pz2l)
**********************************************
* Cuts are applied.....
* all FS momenta are reported in the laboratory
      vboost(3) = -bis
      call boost(gis,vboost,p3,p3)
      call boost(gis,vboost,p4,p4)      
      do kkk = 1,40
         if (qph(kkk,0).gt.0.d0) then
            ptmp(0) = qph(kkk,0)
            ptmp(1) = qph(kkk,1)
            ptmp(2) = qph(kkk,2)
            ptmp(3) = qph(kkk,3)
            call boost(gis,vboost,ptmp,ptmp)
            qph(kkk,0) = ptmp(0) 
            qph(kkk,1) = ptmp(1) 
            qph(kkk,2) = ptmp(2)
            qph(kkk,3) = ptmp(3)         
         endif
      enddo
      call cuts(p3,p4,qph,icut)
      if (icut.eq.1) then
         i_ok = 0
         return
      endif
********************************************
      i1 = ipart1
      i2 = ipart2
      sdif = shard(shat,ccm,i1,i2)
* The jacobian for the MC integration is calculated
!      xjac = (xmax-xmin)*(xmax-xmin) ! this is for x1-2pdf integration
      xjac = pdfjac       * wwpwm
      xjac = xjac*2.d0*pi*xjacccm  ! this is for ccm and phi integration
      xjac = xjac*wpdfpdf          ! for pdfs...
      sdif = sdif*xjac
      ifirst = 0
      return
      end
********************************************************************
      function shard(s,c,ip,jp)
      include 'shared.inc'
      double precision mz2
      E1 = E1cm
      E2 = E2cm
      if (boson.eq.'W') then
*************** SHARD for W production
* c is the cosine of the angle between the up-type quark and the lepton.
* In any case this function is symmetric under c --> -c
         Vud2   = myckm(ip,jp)**2 !1.d0
         Vud2   = 1.d0 !! now it is in the PDFs !!!
         s4tw   = s2tw**2
         
         gw_run = gw*s/mw**2
         gw_run = gw            ! fixed W width !!!
c         call messages(7)

         if ((ip.eq.2).or.(ip.eq.4))   then 
            coseno =  c
            qma    =  m1
            pquark =  pz1
            equark =  E1
         endif
         if ((ip.eq.-1).or.(ip.eq.-3)) then 
            coseno = -c
            qma    =  m2
            pquark =  -pz2
            equark =  E2
         endif
         if ((ip.eq.-2).or.(ip.eq.-4)) then
            coseno =  c
            qma    =  m1
            pquark =  pz1
            equark =  E1
         endif
         if ((ip.eq.1).or.(ip.eq.3)) then
            coseno = -c 
            qma    =  m2
            pquark =  -pz2
            equark =  E2
         endif
         if (ip.eq.-5) then 
            coseno = -c
            qma    =  m2
            pquark =  -pz2
            equark =  E2
         endif
         if (ip.eq.5) then
            coseno = -c
            qma    =  m2
            pquark =  -pz2
            equark =  E2
         endif
         if (i_scheme.eq.4) qma = 0.d0
!!!!!!!!!!         if ((ip.eq.-2).or.(ip.eq.-4)) coseno = -c
!!!!!!!!!!         if ((ip.eq.1).or.(ip.eq.3))   coseno =  c
!! I take massless final state lepton....
         plepton = (E1 + E2)/2.d0
         elepton = plepton

         u_man = qma**2-2.d0*(equark*elepton-coseno*pquark*plepton)
         u2    = u_man**2
         
         u_man_old  = -s/2.d0*(1.d0-coseno)
         u2_old     = u_man_old**2

         den    = (s-mw**2)**2+mw**2*gw_run**2         
         alp = alpha_gf
         if (ischemealpha.eq.0) alp = alpha

         shard  = alp**2*Vud2/s4tw/48.d0 ! /192.d0
         shard  = shard/s*u2
         shard  = shard/den
         shard  = shard * convfac
      else ! if (boson.eq.'Z') then
*************** SHARD for Z production
         modpart = abs(ip)
         kpart   = modpart
         qq      = chq(kpart)

         spine = -0.5d0  ! weak electron isospin
         qe    = -1.d0

         gvq = itre(kpart) - 2.d0*qq*s2tw 
         gaq = itre(kpart)

         gve = spine - 2.d0*qe*s2tw
         gae = spine

         gz_run = gz*s/mz**2
c         call messages(8)
         gz_run = gz      ! fixed Z width !!!
         mz2    =  mz**2
         den    = (s-mz2)**2+mz2*gz_run**2
         if (ip.gt.0) coseno =  c
         if (ip.lt.0) coseno = -c
         r2 = sqrt(2.d0)
c
!         goto 333
c
c$$$         if (ialphachoice.eq.0) alp = alpha
c$$$         if (ialphachoice.eq.1) alp = alpha_gf
c$$$         if (ialphachoice.eq.2) alp = alpha*vpol(s)
c$$$         if (ialphachoice.ge.3) call messages(3)
c$$$         sgffa  = s*gf/alp
c$$$         sgffa2 = sgffa**2
c$$$         qq2 = qq**2
c$$$         fs = qq2 + qe*qq*(gve*gvq/pi/r2 * mz2*(s-mz2)/den)*sgffa
c$$$         fs = fs + (gve**2+gae**2)*(gvq**2+gaq**2)/8/pi/pi *
c$$$     >        mz2**2/den*sgffa2
c$$$         gs = qe*qq*r2*gae*gaq/pi*mz2*(s-mz2)/den*sgffa
c$$$         gs = gs + gve*gae*gvq*gaq/pi/pi*mz2**2/den*sgffa2
c$$$         shard = alp**2/4.d0/s*(fs*(1.d0+coseno**2) + gs*coseno)         
c$$$         shard = shard * convfac * 1.d0 / 3.d0 !! color factor....
*----------------------------------------------------
! more clear to implement the EW scheme....        
 333     continue
         if (ialphachoice.eq.0) alp = alpha
         if (ialphachoice.eq.1) alp = alpha_gf
         if (ialphachoice.eq.2) alp = alpha*vpol(s)
c         if (ialphachoice.eq.2) alp = alpha_gf*vpolnew(s,alpha_gf)
         if (ialphachoice.ge.3) call messages(3)

         modpart = abs(ip)
         qq      = chq(modpart)
         qe      = -1.d0
         spine   = -0.5d0

         gvq = itre(modpart) - 2.d0*qq*s2tw 
         gaq = itre(modpart)

         gve = spine - qe * 2.d0*s2tw
         gae = spine

         e2 = 4.d0*pi*alp 
         e4 = e2**2

         gfp = gf
         gfp = r2*e2/s2tw/8.d0/mw/mw ! ALPHA(0) SCHEME!!!!!!!

         fatt  = gfp*mz2*r2             ! prop. to (g/cos_thw)^2 !!
         rechi = fatt * s * (s-mz2)/den ! "  Z diagram    "
         chim2 = fatt**2 * s**2 / den   ! " |Z diagram|^2 "
         a0 = qq**2*qe**2*e4 *1.d0      !   |photon|^2 
         a0 = a0 +
     >        2.d0*gvq*gve*qq*qe*e2*rechi *1.d0+    ! photon*Z
     >        (gvq**2+gaq**2)*(gve**2+gae**2)*chim2 ! |Z|^2
         a1 = 4.d0*qq*qe*gaq*gae*e2*rechi *1.d0+    ! photon*Z
     >        8.d0*gvq*gaq*gve*gae*chim2            ! |Z|^2

         sss   = a0*(1.d0 + coseno**2) + a1 * coseno
         sss   = sss/64.d0/pi/pi/s * convfac /3.d0 
         shard = sss
*----------------------------------------------------
      endif
      end
********************************************************************
      subroutine get_x1x2pdf(s,w)
      include 'shared.inc'
      real*4 rnd(2),csi(1)
      common/yminimo/ymin
      w = 1.d0
      if (i_pdf.ne.0) then
! I change the integration variables: from x1,x2 to x1,y=x1*x2 (--> x2=y/x1).
! The Jacobian of the transformation is 1/x1.
! Then I sample x1 (xmin < x1 < xmax) according to 1/x1 and y
! (x1*xmin <y < x1*xmax) according to a multi-channel BW or 1/y
         if (boson.eq.'Z') then
            am = mz
            ag = gz
         else
            am = mw
            ag = gw
         endif
*** PDFs go as ~1/x**1.3 for x --> 0 !!
**********
         ymax = xmax*xmax
         sshatmin = 2.d0*ebeam*sqrt(ymin)

         anbw = 1.d0/(s*am*ag)*( atan( ymax*s/am/ag-am/ag )
     >        - atan( ymin*s/am/ag-am/ag ) )
c         aln = log(ymax/ymin)
         a    = 1.3d0

         uma  = 1.d0 - a
         an13 = 1.d0/uma*(ymax**uma - ymin**uma)

         pbw  = 1.d0
         if (sshatmin.gt.70d0.and.boson.eq.'W') pbw = 0.1d0
         if (sshatmin.gt.80d0.and.boson.eq.'Z') pbw = 0.1d0
         pomy = 1.d0 - pbw

*     for y, I use a multi-channel sampling, in order to flatten both BW and
*     1/y (implied by PDFs) peaks.....         
         call wraprng(rnd,2)
         if (rnd(1).lt.pbw) then             
            y    = 1.d0*rnd(2)
            tmp  = atan(ymin*s/am/ag-am/ag)
            y    = ag*am/s*( tan(s*am*ag*anbw*y+tmp)+am/ag )
         else
c            y = ymin*exp(aln*rnd(2))            
c            y = (ymax-ymin)*rnd(2) + ymin ! flat...
            y = uma * an13 * rnd(2) + ymin**uma ! as y**-a
            y = y **(1.d0/uma)
         endif

         wbw  = 1.d0/anbw/((y*s-am**2)**2+am**2*ag**2)
c         womy = 1.d0/y/aln
c         womy = ymax-ymin  ! flat...
         womy  = 1.d0/an13/y**a

         regulator  = 1.d0/(pbw*wbw + pomy*womy)         
         w = w*regulator

         x1min = max(y/xmax,xmin)
         x1max = min(y/xmin,xmax)

         aln = log(x1max/x1min)
         call wraprng(csi,1)
         x1  = x1min*exp(aln*csi(1))
         w   = w * aln * x1
c         x1 = (x1max - x1min) * csi(1) + x1min
c         w  = w * (x1max -x1min)

         yjac = 1/x1
         w    = w*yjac
         
         x1pdf = x1
         x2pdf = y/x1

! simmetrizzo x1 x2, non e' cosi' necessario...
         call wraprng(csi,1)
         if (csi(1).lt.0.5) then
            x1    = x1pdf
            x1pdf = x2pdf
            x2pdf = x1
         endif
      else  ! if the partonic cross section is selected
         x1pdf  = 1.d0        
         x2pdf  = 1.d0
         w = 1.d0       
      endif
      return
      end
**
      subroutine get_x1x2pdf_OLD(s,w)
      include 'shared.inc'
      real*4 rnd(2),csi(1)
      w = 1.d0
      if (i_pdf.ne.0) then
! I change the integration variables: from x1,x2 to x1,y=x1*x2 (--> x2=y/x1).
! The Jacobian of the transformation is 1/x1.
! Then I sample x1 (xmin < x1 < xmax) according to 1/x1 and y
! (x1*xmin <y < x1*xmax) according to a multi-channel BW or 1/y
         if (boson.eq.'Z') then
            am = mz
            ag = gz
         else
            am = mw
            ag = gw
         endif
         aln = log(xmax/xmin)
         call wraprng(csi,1)
         x1  = xmin*exp(aln*csi(1))
         w = w * aln         
         anbw = 1.d0/(s*am*ag)*( atan( x1*xmax*s/am/ag-am/ag )
     >        - atan( x1*xmin*s/am/ag-am/ag ) )

         pbw = 0.5d0
         pomy = 1.d0 - pbw
 
*     for y, I use a multi-channel sampling, in order to flatten both BW and
*     1/y (implied by PDFs) peaks.....
         call wraprng(rnd,2)
         if (rnd(1).lt.pbw) then             
            y    = 1.d0*rnd(2)
            tmp  = atan(x1*xmin*s/am/ag-am/ag)
            y    = ag*am/s*( tan(s*am*ag*anbw*y+tmp)+am/ag )
         else
            y = x1*xmin*exp(aln*rnd(2))            
         endif
         wbw  = 1.d0/anbw/((y*s-am**2)**2+am**2*ag**2)
         womy = 1.d0/y/aln
         regulator  = 1.d0/(pbw*wbw + pomy*womy)
         w = w*regulator
         x1pdf = x1
         x2pdf = y/x1
         if (x1pdf.gt.0.999999) x1pdf = 0.999999  
         if (x2pdf.gt.0.999999) x2pdf = 0.999999  
      else  ! if the partonic cross section is selected
         x1pdf  = 1.d0        
         x2pdf  = 1.d0
         w = 1.d0       
      endif 
      return
      end
********************************************************************
      subroutine get_is(x1,x2,s,weight)
* This subroutine selects the initial state particles (storing the masses,
* the charges and type in the common string 'process')
      include 'shared.inc'
      common/getisfirst/igetis
      data igetis /1/
      if (igetis.eq.1) then
         do j = -ifl,ifl
            do i = -ifl,ifl
               pdfpdf(i,j) = 0.d0
            enddo
         enddo
         igetis = 0
      endif
      call get_pdf(x1,x2,s)
      if (boson.eq.'W') then
         call get_is_W(x1,x2,s,weight)
      else
         call get_is_Z(x1,x2,s,weight)
      endif
      return
      end
********************************************
      subroutine get_is_Z(x1,x2,s,weight)
      include 'shared.inc'
      real*4 rnd(1)
      sumpdfpdf = 0.d0
      psum      = 0.d0
      weight    = 0.d0
      do j = -ifl, ifl
         i = -j
*     no FCNC !!!!!!!!!!!!!!!	 
         pdf1i = pdf1(i) 
         pdf2j = pdf2(j)
         if (pdf1i.lt.0.d0) pdf1i = 0.d0
         if (pdf2j.lt.0.d0) pdf2j = 0.d0
         pdfpdf(i,j) = pdf1i*pdf2j
         sumpdfpdf = sumpdfpdf + pdfpdf(i,j)            
      enddo 
* It can happen that the pdf product for a given x1, x2 is zero for all
* the particles. In this case, no process can occur: I keep ipart1 
* and ipart2 = ifl+1 and the routine exits
      if (sumpdfpdf.eq.0.d0) then        
         ipart1 = ifl+1
         ipart2 = ifl+1
         return
      endif
      weight = sumpdfpdf
* choose the process...
      i_stop = 0
      j=-ifl-1
      call wraprng(rnd,1)
      do while(i_stop.eq.0.and.j.lt.ifl)
         j =  j + 1
         i = -j
         psum   = psum + pdfpdf(i,j)
         psum_n = psum/sumpdfpdf

         if (psum_n.gt.rnd(1)) then ! i,j correspond to 
                                ! the occurring
                                ! process,  when 
                                ! the do-loop stops
            m1  = mq(i)
            m2  = mq(j)
            ch1 = chq(i)
            ch2 = chq(j)               
            ipart1 = i
            ipart2 = j               
            i_stop = 1
         endif
      enddo
      return
      end
********************************************************************
      subroutine get_is_W(x1,x2,s,weight)
      include 'shared.inc'
      real*4 rnd(1)
      common/getiswfirst/ifirst
      data ifirst /1/
      if (ifirst.eq.1) then
c         do k = 1,10
c            print*,'CKM in PDF*PDF, remove it from p.l. x-sect.'
c         enddo
         ifirst = 0
      endif
      sumpdfpdf = 0.d0
      psum      = 0.d0
      weight    = 0.d0

      do j = 1,ifl,2
         do i = 2, ifl,2
            if (chfs.lt.0.d0) then
               i1 = j
               i2 = -i
            else
               i1 = -j
               i2 = i
            endif
            Vud2 = myckm(i1,i2)**2

            if (i_pdf.eq.0) Vud2 = 1.d0

            if (pdf1(i1).lt.0.d0) pdf1(i1) = 0.d0
            if (pdf2(i2).lt.0.d0) pdf2(i2) = 0.d0
            if (pdf1(i2).lt.0.d0) pdf1(i2) = 0.d0
            if (pdf2(i1).lt.0.d0) pdf2(i1) = 0.d0

            pdfpdf(-i1,-i2) = 0.d0
            pdfpdf(-i2,-i1) = 0.d0

            pdfpdf(i1,i2) = pdf1(i1)*pdf2(i2) * Vud2
            pdfpdf(i2,i1) = pdf1(i2)*pdf2(i1) * Vud2
            sumpdfpdf = sumpdfpdf + pdfpdf(i1,i2) + pdfpdf(i2,i1)            
         enddo
      enddo 
* It can happen that the pdf product for a given x1, x2 is zero for all
* the particles. In this case, no process can occur: I keep ipart1 
* and ipart2 = ifl+1 and the routine exits
      if (sumpdfpdf.eq.0.d0) then        
         ipart1 = ifl + 1
         ipart2 = ifl + 1
         return
      endif
      weight = sumpdfpdf
* choose the process...
      i_stop = 0     
      j= -ifl - 1
      call wraprng(rnd,1)
      do while(i_stop.eq.0.and.j.lt.ifl)
         j =  j + 1         
         i = -ifl-1
         do while(i_stop.eq.0.and.i.lt.ifl)
               i = i + 1
               if (i.ne.j.and.i.ne.0.and.j.ne.0) then
               psum   = psum + pdfpdf(i,j)
               psum_n = psum/sumpdfpdf               
               if (psum_n.gt.rnd(1)) then
                  m1  = mq(i)
                  m2  = mq(j)
                  ch1 = chq(i)
                  ch2 = chq(j)
                  ipart1 = i
                  ipart2 = j               
                  i_stop = 1
               endif
            endif
         enddo
      enddo
      return
      end
***********************************************************
      subroutine get_pdf(x1,x2,s)
      include 'shared.inc'
* The initial state is selected. For example, the process initiated by
* u d_bar is kept distinguished from the d_bar u, since in the proton and
* anti-proton the PDF quark content is different....
      if (i_pdf.ne.0) then   ! if the PDF cross section is selected....
* PDF called for hadron 1
         call pdf_wrapper(x1,s,up,down,aup,adown,str,ch,bot,glu)
         if (hadr1.eq.2212) then  ! if the hadron is a proton....
            pdf1(1)  = down
            pdf1(2)  = up
            pdf1(3)  = str
            pdf1(4)  = ch
            pdf1(5)  = bot
            pdf1(-1) = adown
            pdf1(-2) = aup
            pdf1(-3) = str
            pdf1(-4) = ch
            pdf1(-5) = bot
         else ! else, if it is an antiproton....
            pdf1(-1) = down
            pdf1(-2) = up
            pdf1(-3) = str
            pdf1(-4) = ch
            pdf1(-5) = bot
            pdf1(1)  = adown
            pdf1(2)  = aup
            pdf1(3)  = str
            pdf1(4)  = ch
            pdf1(5)  = bot
         endif	
c         do i= -ifl, ifl ! checked after!!
c            if (pdf1(i).lt.0.d0) pdf1(i)=0.d0
c         enddo    
* PDF called for hadron 2
         call pdf_wrapper(x2,s,up,down,aup,adown,str,ch,bot,glu)     
         if (hadr2.eq.2212) then ! if the hadron is a proton....
            pdf2(1)  = down
            pdf2(2)  = up
            pdf2(3)  = str
            pdf2(4)  = ch
            pdf2(5)  = bot
            pdf2(-1) = adown
            pdf2(-2) = aup
            pdf2(-3) = str
            pdf2(-4) = ch
            pdf2(-5) = bot
         else                   ! else, if it is an antiproton....
            pdf2(-1) = down
            pdf2(-2) = up
            pdf2(-3) = str
            pdf2(-4) = ch
            pdf2(-5) = bot
            pdf2(1)  = adown
            pdf2(2)  = aup
            pdf2(3)  = str
            pdf2(4)  = ch
            pdf2(5)  = bot
         endif
c         do i = -ifl, ifl ! checked after!!
c            if (pdf2(i).lt.0.d0) pdf2(i)=0.d0
c         enddo    
      else  ! if the partonic cross section is selected....
         pdf1(iquark1)  = 1.d0
         pdf2(iquark2)  = 1.d0
      endif
      return
      end
************************************************************************
      function ccmgen(w)
* generate -1 < x < 1 according to 1+x^2 con un bicanale
      implicit double precision (a-h,o-z)
      real*4 random(2)      
      call wraprng(random,2)
c      ccmgen = 2.d0*random(1)-1.d0
c      w      = 2.d0
c      return
      an1   = 2.d0
      an2   = 2.d0/3.d0
      anorm = an1 + an2
      csi   = random(1)*anorm
      if (csi.lt.an1) then         
         x = an1*random(2)-1.d0
      else         
         arg  = 3.d0*(random(2)*an2-1.d0/3.d0)
         aarg = dabs(arg)
	 if (arg.gt.0.d0) then
	    segno =  1.d0
	 else
	    segno = -1.d0
	 endif      
         x = segno*aarg**(1.d0/3.d0)
      endif
      ccmgen = x
      w = anorm/(1.d0+x**2)
      return
      end
